diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java
index 559ff5511..8316d0f54 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblock.java
@@ -5,16 +5,17 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
 public class ChunkGeneratorSkyblock
     extends ChunkGenerator {
 
-    public ChunkGeneratorSkyblock(World world) {
+    public ChunkGeneratorSkyblock(@NotNull World world) {
         super(world, new ChunkDecoratorSkyblock());
     }
 
     @Override
-    protected ChunkGeneratorResult doBlockGeneration(Chunk chunk) {
+    protected @NotNull ChunkGeneratorResult doBlockGeneration(@NotNull Chunk chunk) {
         ChunkGeneratorResult result = new ChunkGeneratorResult();
 
         // Starting island
@@ -54,11 +55,11 @@ public class ChunkGeneratorSkyblock
         return result;
     }
 
-    private boolean contains(Chunk chunk, int xBlock, int zBlock) {
+    private boolean contains(@NotNull Chunk chunk, int xBlock, int zBlock) {
         return chunk.pos.x == xBlock >> 4 && chunk.pos.z == zBlock >> 4;
     }
 
-    private void tryPlace(Chunk chunk, ChunkGeneratorResult result, int xBlock, int yBlock, int zBlock, int blockId) {
+    private void tryPlace(@NotNull Chunk chunk, @NotNull ChunkGeneratorResult result, int xBlock, int yBlock, int zBlock, int blockId) {
         if (contains(chunk, xBlock, zBlock)) {
             result.setBlock(xBlock & (Chunk.CHUNK_SIZE_X - 1), yBlock, zBlock & (Chunk.CHUNK_SIZE_Z - 1), blockId);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java
index 5111ca851..939208b22 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/skyblock/ChunkGeneratorSkyblockNether.java
@@ -5,16 +5,17 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
+import org.jetbrains.annotations.NotNull;
 
 public class ChunkGeneratorSkyblockNether
     extends ChunkGenerator {
 
-    public ChunkGeneratorSkyblockNether(World world) {
+    public ChunkGeneratorSkyblockNether(@NotNull World world) {
         super(world, new ChunkDecoratorSkyblockNether());
     }
 
     @Override
-    protected ChunkGeneratorResult doBlockGeneration(Chunk chunk) {
+    protected @NotNull ChunkGeneratorResult doBlockGeneration(@NotNull Chunk chunk) {
         ChunkGeneratorResult result = new ChunkGeneratorResult();
 
         // Main island
@@ -45,11 +46,11 @@ public class ChunkGeneratorSkyblockNether
         return result;
     }
 
-    private boolean contains(Chunk chunk, int xBlock, int zBlock) {
+    private boolean contains(@NotNull Chunk chunk, int xBlock, int zBlock) {
         return chunk.pos.x == xBlock >> 4 && chunk.pos.z == zBlock >> 4;
     }
 
-    private void tryPlace(Chunk chunk, ChunkGeneratorResult result, int xBlock, int yBlock, int zBlock, int blockId) {
+    private void tryPlace(@NotNull Chunk chunk, @NotNull ChunkGeneratorResult result, int xBlock, int yBlock, int zBlock, int blockId) {
         if (contains(chunk, xBlock, zBlock)) {
             result.setBlock(xBlock & (Chunk.CHUNK_SIZE_X - 1), yBlock, zBlock & (Chunk.CHUNK_SIZE_Z - 1), blockId);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngine.java b/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngine.java
index ec7d82e8f..7ed37814b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngine.java
+++ b/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngine.java
@@ -7,5 +7,7 @@ public interface LightingEngine {
 
     boolean updatingLighting();
 
+    int pendingUpdates();
+
     void scheduleLightingUpdate(LightLayer layer, int minX, int minY, int minZ, int maxX, int maxY, int maxZ);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java b/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
index 1262b50e4..4290a2082 100644
--- a/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
@@ -1,10 +1,13 @@
 package net.minecraft.core.world.lighting;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
@@ -15,7 +18,7 @@ import static net.minecraft.core.world.World.MAX_BRIGHTNESS;
 
 public class LightingEngineLegacy implements LightingEngine {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private final List<LightUpdate> lightingToUpdate = new LinkedList<>();
+    private final List<LightUpdate> lightingToUpdate = new ObjectArrayList<>();
     private int lightingUpdatesCounter = 0;
     private int lightingUpdatesScheduled = 0;
 
@@ -50,6 +53,11 @@ public class LightingEngineLegacy implements LightingEngine {
         }
     }
 
+    @Override
+    public int pendingUpdates() {
+        return this.lightingToUpdate.size();
+    }
+
     @Override
     public void scheduleLightingUpdate(final LightLayer layer, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ) {
         if(this.world.worldType.hasCeiling() && layer == LightLayer.Sky)
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
index d3b7d675d..ef403fab2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
@@ -6,7 +6,7 @@ import net.minecraft.core.world.chunk.Chunk;
 import org.jetbrains.annotations.NotNull;
 
 public final class ChunkPos
- implements Pos2i<ChunkPos> {
+    implements Pos2i<ChunkPos> {
     public int x;
     public int z;
 
@@ -22,6 +22,13 @@ public final class ChunkPos
         );
     }
 
+    public ChunkPos(final @NotNull ChunkPos chunkPos) {
+        this(
+            chunkPos.x,
+            chunkPos.z
+        );
+    }
+
     public ChunkPos(final @NotNull Entity entity) {
         this(
             MathHelper.floor(entity.x / (double) Chunk.CHUNK_SIZE_X),
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
index 7a8a5571f..c90dfc6c5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkTilePos.java
@@ -8,7 +8,7 @@ import net.minecraft.core.world.chunk.ChunkSection;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public final class ChunkTilePos
+public class ChunkTilePos
     implements Pos3i<ChunkTilePos> {
     public int x;
     public int y;
diff --git a/game/core/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java b/game/core/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java
index c2d068a1d..e3a3997c7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java
+++ b/game/core/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.season;
 import net.minecraft.core.Global;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.config.season.SeasonConfigCycle;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Collections;
 import java.util.List;
@@ -13,6 +14,9 @@ public final class SeasonManagerCycle
     private final SeasonConfigCycle config;
     private final int yearLengthTicks;
 
+    private long lastQueryTime = Long.MIN_VALUE;
+    private @NotNull Season lastQueredSeason = Seasons.NULL;
+
     public SeasonManagerCycle(World world, SeasonConfigCycle config)
     {
         super(world);
@@ -73,6 +77,7 @@ public final class SeasonManagerCycle
     public Season getCurrentSeason()
     {
         long worldTime = world.getWorldTime();
+        if (worldTime == lastQueryTime) return lastQueredSeason;
         int yearTime = (int)(worldTime % yearLengthTicks);
         int acc = 0;
 
@@ -80,6 +85,8 @@ public final class SeasonManagerCycle
         {
             if (acc + getSeasonLengthTicks(season) > yearTime)
             {
+                lastQueryTime = worldTime;
+                lastQueredSeason = season;
                 return season;
             }
             acc += getSeasonLengthTicks(season);
diff --git a/game/core/src/main/resources/lang/en_US/options.lang b/game/core/src/main/resources/lang/en_US/options.lang
index baf3dd3a3..d718e3486 100644
--- a/game/core/src/main/resources/lang/en_US/options.lang
+++ b/game/core/src/main/resources/lang/en_US/options.lang
@@ -189,6 +189,10 @@ options.enableHolidayTextures=Enable Holiday Textures
 options.dynamicCursor=Dynamic Cursor
 options.enableDevResourceLoading=Developer Resource Loading
 options.enableMultiDrawRendering=Enable Multi-Draw Renderer (experimental!)
+options.enableThreadedChunkProvider=Enable Threaded Chunk Provider (experimental!)
+options.enableThreadedChunkProvider.static=Static
+options.enableThreadedChunkProvider.dynamic=Dynamic
+options.enableThreadedChunkProvider.threaded=Threaded
 options.doJCECheck=Do JCE Check
 options.musicToasts=Music Toasts
 options.musicFrequency=Music Frequency
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index dc2752fda..19c2e6f32 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -161,6 +161,7 @@ public class MinecraftServer
     public String language;
     public int sleepPercentage = 100;
     public int maxPlayers = 20;
+    public int viewDistance = 10;
     public Gamemode defaultGamemode;
     public static String statsToken;
     public static boolean statsStatus;
@@ -268,6 +269,7 @@ public class MinecraftServer
         NetworkManager.PACKET_DELAY = propertyManager.getIntProperty("packet-delay", 1);
         NetworkManager.TIMEOUT_TIME = propertyManager.getIntProperty("login-timeout-time", 1800 * 50);
         maxPlayers = propertyManager.getIntProperty("max-players", 20);
+        viewDistance = propertyManager.getIntProperty("view-distance", 10);
         language = propertyManager.getStringProperty("language", "en_US");
         disablePhotoMode = propertyManager.getBooleanProperty("disable-photomode", false);
         name = propertyManager.getStringProperty("name", "");
@@ -337,7 +339,7 @@ public class MinecraftServer
         int namespaces = Registries.RECIPES.size();
         int itemGroups = Registries.ITEM_GROUPS.size();
         logInfo(String.format("%d item groups.",itemGroups));
-        logInfo(String.format("%d recipes in %d groups in %d namespaces.",recipes,groups,namespaces));
+        logInfo(String.format("%d recipes in %d groups in %d namespaces.", recipes, groups, namespaces));
         
         SoundTypes.registerSounds();
         
@@ -649,6 +651,10 @@ public class MinecraftServer
             playerList.savePlayerStates();
         }
         saveServerWorld();
+        for (WorldServer worldServer : dimensionWorlds.values())
+        {
+            worldServer.close();
+        }
     }
 
     public void initiateShutdown()
diff --git a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
index 8495a5036..d10f88708 100644
--- a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -64,7 +64,7 @@ public class PlayerList
         ipBansFile = server.getFile("banned-ips.txt");
         opsFile = server.getFile("ops.txt");
         whitelistFile = server.getFile("white-list.txt");
-        int viewDistance = server.propertyManager.getIntProperty("view-distance", 10);
+        int viewDistance = server.viewDistance;
         for (int dim : Dimension.getDimensionList().keySet())
         {
             playerManagers.put(dim, new PlayerManager(server, dim, viewDistance));
diff --git a/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java b/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
index 700807044..74fb5bb81 100644
--- a/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
+++ b/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
@@ -7,6 +7,7 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.net.packet.*;
+import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.server.entity.player.PlayerServer;
 import net.minecraft.server.net.PlayerHash;
 import net.minecraft.core.world.chunk.Chunk;
@@ -235,7 +236,7 @@ public class PlayerManager
                 if (numBlocksToUpdate > 0) {
                     playerInstancesToUpdate.remove(this);
                 }
-                server.getDimensionWorld(dimension).chunkProviderServer.dropChunk(chunkX, chunkZ);
+                server.getDimensionWorld(dimension).chunkProviderServer.dropChunk(new ChunkPos(chunkX, chunkZ));
             }
             player.loadedChunks.remove(currentChunk);
             if (player.field_420_ah.contains(currentChunk)) {
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index db87dc28b..c38d8f486 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -24,6 +24,12 @@ import org.jetbrains.annotations.NotNull;
 
 public class WorldServer extends World
 {
+    public ChunkProviderServer chunkProviderServer;
+    public boolean dontSave;
+    public MinecraftServer mcServer;
+    private final Int2ObjectMap<Entity> entityIntHashMap;
+    private long lastWeatherSend = System.currentTimeMillis();
+
 
     public WorldServer(MinecraftServer minecraftserver, LevelStorage isavehandler, String name, int dimensionId, WorldType worldType, long seed)
     {
@@ -212,7 +218,6 @@ public class WorldServer extends World
     {
         saveHandler.checkSessionLock();
     }
-
     @Override
     public void tick() {
         super.tick();
@@ -222,11 +227,11 @@ public class WorldServer extends World
             lastWeatherSend = System.currentTimeMillis();
         }
     }
+
     @Override
     public void sendGlobalMessage(String message){
         mcServer.playerList.sendPacketToAllPlayers(new PacketChat(message));
     }
-
     @Override
     public void addRainbow(int rainbowTicks){
         byte b0 = (byte) ((rainbowTicks >> 24) & 0xFF);
@@ -238,9 +243,9 @@ public class WorldServer extends World
         mcServer.playerList.sendPacketToAllPlayersInDimension(new PacketCustomPayload(PacketCustomPayload.CHANNEL_RAINBOW_START, new byte[]{b0, b1, b2, b3}), dimension.id);
         super.addRainbow(rainbowTicks);
     }
-    public ChunkProviderServer chunkProviderServer;
-    public boolean dontSave;
-    public MinecraftServer mcServer;
-    private final Int2ObjectMap<Entity> entityIntHashMap;
-    private long lastWeatherSend = System.currentTimeMillis();
+
+    @Override
+    public int renderDistance() {
+        return mcServer.viewDistance;
+    }
 }
